"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  CardPlainContent: true,
  CardContent: true,
  Card: true,
  PanelCard: true
};
exports.PanelCard = exports.CardPlainContent = exports.CardContent = exports.Card = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _padding = require("./padding");

var _jsxRuntime = require("react/jsx-runtime");

var _CardHeader = require("./CardHeader");

Object.keys(_CardHeader).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _CardHeader[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _CardHeader[key];
    }
  });
});

var _CardFooter = require("./CardFooter");

Object.keys(_CardFooter).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _CardFooter[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _CardFooter[key];
    }
  });
});

var _CardTabs = require("./CardTabs");

Object.keys(_CardTabs).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _CardTabs[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _CardTabs[key];
    }
  });
});
var _excluded = ["width", "square", "children"],
    _excluded2 = ["width", "square", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CardDiv = _styledComponents.default.div.withConfig({
  displayName: "Card__CardDiv",
  componentId: "sc-1law0n3-0"
})(["overflow:hidden;height:100%;", ";"], _ref => {
  var {
    theme
  } = _ref;
  return (0, _styledComponents.css)(["background-color:", ";color:", ";box-shadow:", ";"], theme.color.background00(), theme.color.text01(), theme.shadow.card);
});

var CardContainer = (0, _styledComponents.default)(CardDiv).withConfig({
  displayName: "Card__CardContainer",
  componentId: "sc-1law0n3-1"
})(["flex:none;display:inline-flex;flex-direction:column;align-items:stretch;width:", ";", ""], _ref2 => {
  var {
    width
  } = _ref2;
  return width === 'full' ? '100%' : width === 'small' ? '400px' : '600px';
}, _ref3 => {
  var {
    square
  } = _ref3;
  return square ? undefined : (0, _styledComponents.css)(["border-radius:", ";"], _designparams.shape.radius.large);
});
var PanelCardContainer = (0, _styledComponents.default)(CardDiv).withConfig({
  displayName: "Card__PanelCardContainer",
  componentId: "sc-1law0n3-2"
})(["width:100%;height:100%;display:inline-flex;flex-direction:column;align-items:center;justify-content:space-evenly;min-width:", ";", ""], _ref4 => {
  var {
    width
  } = _ref4;
  return width === 'full' ? '100%' : width === 'small' ? '400px' : '600px';
}, _ref5 => {
  var {
    square
  } = _ref5;
  return square ? undefined : (0, _styledComponents.css)(["border-radius:", ";"], _designparams.shape.radius.large);
});

var CardPlainContent = _styledComponents.default.div.withConfig({
  displayName: "Card__CardPlainContent",
  componentId: "sc-1law0n3-3"
})(["display:flex;flex-direction:column;flex:auto;padding:0 ", ";"], _padding.CARD_PADDING);

exports.CardPlainContent = CardPlainContent;
var CardContent = (0, _styledComponents.default)(CardPlainContent).withConfig({
  displayName: "Card__CardContent",
  componentId: "sc-1law0n3-4"
})(["padding:", " ", " ", ";"], _designparams.spacing.large, _padding.CARD_PADDING, _designparams.spacing.huge);
exports.CardContent = CardContent;

var Card = _ref6 => {
  var {
    width = 'full',
    square = true,
    children
  } = _ref6,
      props = _objectWithoutProperties(_ref6, _excluded);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(CardContainer, _objectSpread(_objectSpread({
    width: width,
    square: square
  }, props), {}, {
    children: children
  }));
};

exports.Card = Card;

var PanelCard = _ref7 => {
  var {
    width = 'full',
    square = true,
    children
  } = _ref7,
      props = _objectWithoutProperties(_ref7, _excluded2);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(PanelCardContainer, _objectSpread(_objectSpread({
    width: width,
    square: square
  }, props), {}, {
    children: children
  }));
};

exports.PanelCard = PanelCard;