"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MultiSelect = MultiSelect;
exports.MultiSelectField = void 0;

var _react = require("react");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _designparams = require("../designparams");

var _Icon = require("../Icon");

var _Chip = require("../Chip");

var _withField = require("../utils/withField");

var _BaseSelect = require("./BaseSelect");

var _Select = require("./Select");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["value", "options", "onChange", "placeholder"],
    _excluded2 = ["label"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var StyledChip = (0, _styledComponents.default)(_Chip.Chip).withConfig({
  displayName: "MultiSelect__StyledChip",
  componentId: "sc-14djwu2-0"
})(["background-color:", ";margin:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.element13();
}, _designparams.spacing.small);

var SelectInsideContainer = _styledComponents.default.div.withConfig({
  displayName: "MultiSelect__SelectInsideContainer",
  componentId: "sc-14djwu2-1"
})(["width:100%;display:flex;justify-content:space-between;align-items:center;overflow:hidden;"]);

var ChipContainer = _styledComponents.default.div.withConfig({
  displayName: "MultiSelect__ChipContainer",
  componentId: "sc-14djwu2-2"
})(["display:flex;flex-grow:1;flex-wrap:wrap;overflow:hidden;"]);

var IconsContainer = _styledComponents.default.div.withConfig({
  displayName: "MultiSelect__IconsContainer",
  componentId: "sc-14djwu2-3"
})(["display:flex;align-self:stretch;align-items:center;padding:", ";"], _designparams.spacing.medium);

var Divider = _styledComponents.default.div.withConfig({
  displayName: "MultiSelect__Divider",
  componentId: "sc-14djwu2-4"
})(["width:1px;background-color:", ";align-self:stretch;margin:", " 0;"], _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.element12();
}, _designparams.spacing.small);

function MultiSelect(_ref3) {
  var {
    value,
    options,
    onChange,
    placeholder = ''
  } = _ref3,
      props = _objectWithoutProperties(_ref3, _excluded);

  var onRemoveAllClick = (0, _react.useCallback)(event => {
    event.stopPropagation();
    onChange === null || onChange === void 0 ? void 0 : onChange([]);
  }, [onChange]);
  var handleRemoveAllKeyDown = (0, _react.useCallback)(event => {
    if (event.key === 'Enter') {
      event.stopPropagation();
      onChange === null || onChange === void 0 ? void 0 : onChange([]);
    }
  }, [onChange]);
  var onMultiChange = (0, _react.useCallback)(nextValue => onChange === null || onChange === void 0 ? void 0 : onChange([...value, nextValue]), [value, onChange]);
  var chips = (0, _react.useMemo)(() => value.map(v => {
    var _options$find$label, _options$find;

    return {
      label: (_options$find$label = (_options$find = options.find(option => option.value === v)) === null || _options$find === void 0 ? void 0 : _options$find.label) !== null && _options$find$label !== void 0 ? _options$find$label : '',
      onRemove: () => {
        onChange === null || onChange === void 0 ? void 0 : onChange(value.filter(v2 => v2 !== v));
      }
    };
  }), [onChange, options, value]);
  var component = (0, _react.useMemo)(() => {
    if (value.length === 0) {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Select.PlaceholderContainer, {
        children: placeholder
      });
    }

    return /*#__PURE__*/(0, _jsxRuntime.jsxs)(SelectInsideContainer, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ChipContainer, {
        children: value.map((v, i) => /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledChip, {
          text: chips[i].label,
          onRemove: chips[i].onRemove
        }, v))
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(IconsContainer, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.ClickableIcon, {
          size: "small",
          icon: _practicalReactComponentsIcons.CloseIcon,
          onClick: onRemoveAllClick,
          onKeyDown: handleRemoveAllKeyDown
        })
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(Divider, {})]
    });
  }, [chips, onRemoveAllClick, handleRemoveAllKeyDown, placeholder, value]);
  var notSelectedOptions = (0, _react.useMemo)(() => options.filter(o => !value.includes(o.value)).map(_ref4 => {
    var {
      label
    } = _ref4,
        rest = _objectWithoutProperties(_ref4, _excluded2);

    return _objectSpread(_objectSpread({}, rest), {}, {
      component: label
    });
  }), [options, value]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseSelect.BaseSelect, _objectSpread(_objectSpread({
    value: "",
    options: notSelectedOptions,
    component: component
  }, props), {}, {
    onChange: onMultiChange
  }));
}

var MultiSelectField = props => (0, _withField.withField)(MultiSelect)(props);

exports.MultiSelectField = MultiSelectField;