"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WidthActionType = exports.TableContext = void 0;

var _react = require("react");

var WidthActionType;
exports.WidthActionType = WidthActionType;

(function (WidthActionType) {
  WidthActionType[WidthActionType["SET_WIDTHS"] = 0] = "SET_WIDTHS";
  WidthActionType[WidthActionType["UPDATE_WIDTHS"] = 1] = "UPDATE_WIDTHS";
  WidthActionType[WidthActionType["RESET_WIDTHS"] = 2] = "RESET_WIDTHS";
  WidthActionType[WidthActionType["SET_TOTAL_WIDTH"] = 3] = "SET_TOTAL_WIDTH";
})(WidthActionType || (exports.WidthActionType = WidthActionType = {}));

/*******************************************************************************
 *
 * TableContext
 *
 * Keeps track of table-wide properties which need to
 * be accessible from within each of the subcomponents.
 *
 ******************************************************************************/
var TableContext = /*#__PURE__*/(0, _react.createContext)({
  minColumnWidth: 0,
  columnWidths: [],
  dispatchWidthsAction: () => {
    /** */
  },
  selectWidth: 0,
  menuWidth: 0,
  hasMenu: false,
  onWidthsChange: () => {
    /** */
  }
});
exports.TableContext = TableContext;