import { HTMLAttributes } from 'react';
import { BaseToastValue, ToastId } from './context';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = HTMLAttributes<BaseElement>;
interface BaseToastProps extends BaseToastValue, BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    readonly toastId: ToastId;
    readonly dismissToast: (id: ToastId) => void;
    readonly zIndex: number;
}
/**
 * A basic container for all kinds of toasts.
 * Child elements are passed as props.
 */
export declare const BaseToast: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<BaseToastProps & import("react").RefAttributes<HTMLDivElement | null>>>;
export {};
